package sun.awt.macos;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Graphics;
import java.awt.MenuComponent;
import java.awt.peer.ComponentPeer;
import java.awt.peer.MenuComponentPeer;

public class InterfaceThread implements Runnable {
   static Object mInterfaceQueueWaitObject = new Object();
   static Object mInterfaceQueueSyncObject = new Object();
   static Thread mInterfaceThread = null;

   public native void run();

   public void dispatchInterfaceEvent() {
      try {
         Object var6 = mInterfaceQueueWaitObject;
         synchronized(var6){}

         try {
            if (InterfaceEvent.firstEvent() == null) {
               mInterfaceQueueWaitObject.wait();
            }
         } catch (Throwable var15) {
            throw var15;
         }
      } catch (InterruptedException var16) {
      }

      Object var20 = mInterfaceQueueSyncObject;
      synchronized(var20){}

      InterfaceEvent var1;
      try {
         var1 = InterfaceEvent.firstEvent();
         if (var1 != null) {
            var1.dequeue();
         }
      } catch (Throwable var14) {
         throw var14;
      }

      if (var1 != null) {
         Component var2 = var1.getComponent();
         switch (var1.getType()) {
            case 1:
               Dimension var21 = var2.size();
               Graphics var19 = var2.getGraphics();
               var19.setColor(var2.getBackground());
               var19.fillRect(0, 0, var21.width, var21.height);
               var19.setColor(var2.getForeground());
               var19.setFont(var2.getFont());
               var2.paint(var19);
               return;
            case 2:
               Graphics var5 = var2.getGraphics();
               var5.clipRect(var1.getX(), var1.getY(), var1.getWidth(), var1.getHeight());
               var2.update(var5);
               return;
            case 3:
               MacintoshEvent var7 = new MacintoshEvent(var2, var1.getWhen(), 501, var1.getX(), var1.getY(), 0, var1.getFlags(), (Object)null, var1.getEventNumber());
               var7.clickCount = var1.getClickCount();
               var2.postEvent(var7);
               return;
            case 4:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 502, var1.getX(), var1.getY(), 0, var1.getFlags(), (Object)null, var1.getEventNumber()));
               return;
            case 5:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 503, var1.getX(), var1.getY(), 0, var1.getFlags(), (Object)null, 0));
               return;
            case 6:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 506, var1.getX(), var1.getY(), 0, var1.getFlags(), (Object)null, 0));
               return;
            case 7:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 401, var1.getX(), var1.getY(), var1.getKey(), var1.getFlags(), (Object)null, var1.getEventNumber()));
               return;
            case 8:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 402, var1.getX(), var1.getY(), var1.getKey(), var1.getFlags(), (Object)null, var1.getEventNumber()));
               return;
            case 9:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 403, var1.getX(), var1.getY(), var1.getKey(), var1.getFlags(), (Object)null, var1.getEventNumber()));
               return;
            case 10:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 404, var1.getX(), var1.getY(), var1.getKey(), var1.getFlags(), (Object)null, var1.getEventNumber()));
               return;
            case 11:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 504, var1.getX(), var1.getY(), 0, var1.getFlags(), (Object)null, 0));
               return;
            case 12:
               var2.postEvent(new MacintoshEvent(var2, var1.getWhen(), 505, var1.getX(), var1.getY(), 0, var1.getFlags(), (Object)null, 0));
               return;
            case 13:
               ComponentPeer var18 = var2.getPeer();
               ((ActionComponent)var18).action();
               return;
            case 14:
               ComponentPeer var17 = var2.getPeer();
               ((ActionComponent)var17).action(var1.getActionState());
               return;
            case 15:
               ComponentPeer var3 = var2.getPeer();
               ((ActionComponent)var3).action(var1.getFlags());
               return;
            case 16:
               MenuComponentPeer var4 = var1.getMenuComponent().getPeer();
               ((ActionComponent)var4).action(var1.getFlags());
               return;
            case 17:
               var2.postEvent(new Event(var2, 701, new Integer(var1.getFlags())));
               return;
            case 18:
               var2.postEvent(new Event(var2, 702, new Integer(var1.getFlags())));
               return;
         }
      }

   }

   static void postInterfaceEvent(int var0, Component var1, MenuComponent var2, int var3, int var4, int var5, int var6, long var7, int var9, int var10, int var11, boolean var12, int var13) {
      if (mInterfaceThread == null) {
         mInterfaceThread = new Thread(new InterfaceThread(), "AWT Interface Thread");
         mInterfaceThread.start();
      }

      InterfaceEvent var14 = new InterfaceEvent(var0, var1, var2, var3, var4, var5, var6, var7, var9, var10, var11, var12, var13);
      Object var15 = mInterfaceQueueSyncObject;
      synchronized(var15) {
         if (var14.enqueue()) {
            Object var17 = mInterfaceQueueWaitObject;
            synchronized(var17){}

            try {
               mInterfaceQueueWaitObject.notify();
            } catch (Throwable var20) {
               throw var20;
            }
         }
      }

   }

   static void postInterfaceEvent(int var0, Component var1, int var2, int var3, int var4, int var5, long var6, int var8, int var9, int var10, int var11) {
      postInterfaceEvent(var0, var1, (MenuComponent)null, var2, var3, var4, var5, var6, var8, var9, var10, false, var11);
   }

   static void postInterfaceEvent(int var0, Component var1, int var2, int var3, int var4, int var5, long var6, int var8, int var9) {
      postInterfaceEvent(var0, var1, (MenuComponent)null, var2, var3, var4, var5, var6, var8, var9, 0, false, 0);
   }

   static void postInterfaceEvent(int var0, Component var1, int var2) {
      postInterfaceEvent(var0, var1, (MenuComponent)null, 0, 0, 0, 0, 0L, var2, 0, 0, false, 0);
   }

   static void postInterfaceEvent(Component var0) {
      postInterfaceEvent(13, var0, (MenuComponent)null, 0, 0, 0, 0, 0L, 0, 0, 0, false, 0);
   }

   static void postInterfaceEvent(Component var0, int var1) {
      postInterfaceEvent(15, var0, (MenuComponent)null, 0, 0, 0, 0, 0L, var1, 0, 0, false, 0);
   }

   static void postInterfaceEvent(Component var0, boolean var1) {
      postInterfaceEvent(14, var0, (MenuComponent)null, 0, 0, 0, 0, 0L, 0, 0, 0, var1, 0);
   }

   static void postInterfaceEvent(MenuComponent var0, int var1) {
      postInterfaceEvent(16, (Component)null, var0, 0, 0, 0, 0, 0L, 0, var1, 0, false, 0);
   }
}
