package sun.awt.macos;

import java.awt.AWTError;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.event.TextEvent;
import java.awt.peer.TextAreaPeer;

public class MTextAreaPeer extends MComponentPeer implements TextAreaPeer {
   Boolean mEditable;

   public MTextAreaPeer(TextArea var1) {
      super(var1);
   }

   native void create(MComponentPeer var1);

   void initialize() {
      TextArea var1 = (TextArea)super.target;
      String var2;
      if ((var2 = ((TextComponent)var1).getText()) != null) {
         this.setText(var2);
      }

      this.select(((TextComponent)var1).getSelectionStart(), ((TextComponent)var1).getSelectionEnd());
      this.setEditable(((TextComponent)var1).isEditable());
      super.initialize();
   }

   public void setBackground(Color var1) {
      TextArea var2 = (TextArea)super.target;
      if (((TextComponent)var2).isEditable()) {
         var1 = var1.brighter();
      }

      super.setBackground(var1);
   }

   public native void setEditable(boolean var1);

   public native void select(int var1, int var2);

   public native int getSelectionStart();

   public native int getSelectionEnd();

   public native void setText(String var1);

   public native String getText();

   public native void insertText(String var1, int var2);

   public native void replaceText(String var1, int var2, int var3);

   public native void reshape(int var1, int var2, int var3, int var4);

   public void setCaretPosition(int var1) {
      throw new AWTError("setCaretPosition is unimplemented.");
   }

   public int getCaretPosition() {
      throw new AWTError("getCaretPosition is unimplemented.");
   }

   public void insert(String var1, int var2) {
      this.insertText(var1, var2);
   }

   public void replaceRange(String var1, int var2, int var3) {
      this.replaceText(var1, var2, var3);
   }

   public Dimension getPreferredSize(int var1, int var2) {
      return this.preferredSize(var1, var2);
   }

   public Dimension getMinimumSize(int var1, int var2) {
      return this.minimumSize(var1, var2);
   }

   public Dimension minimumSize() {
      return this.minimumSize(10, 60);
   }

   public Dimension preferredSize(int var1, int var2) {
      return this.minimumSize(var1, var2);
   }

   public Dimension minimumSize(int var1, int var2) {
      FontMetrics var3 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      return new Dimension(var3.charWidth('0') * var2 + 20, var3.getHeight() * var1 + 20);
   }

   public boolean isFocusTraversable() {
      return true;
   }

   protected void handleTextChanged() {
      MToolkit.postEvent(new TextEvent(super.target, 900));
   }
}
