package sun.awt.macos;

import java.awt.AWTError;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.TextComponent;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.TextEvent;
import java.awt.peer.TextFieldPeer;

public class MTextFieldPeer extends MComponentPeer implements TextFieldPeer {
   public MTextFieldPeer(TextField var1) {
      super(var1);
   }

   native void create(MComponentPeer var1);

   void initialize() {
      TextField var1 = (TextField)super.target;
      this.setText(((TextComponent)var1).getText());
      if (var1.echoCharIsSet()) {
         this.setEchoCharacter(var1.getEchoChar());
      }

      this.select(((TextComponent)var1).getSelectionStart(), ((TextComponent)var1).getSelectionEnd());
      this.setEditable(((TextComponent)var1).isEditable());
      super.initialize();
   }

   public void setBackground(Color var1) {
      TextField var2 = (TextField)super.target;
      if (((TextComponent)var2).isEditable()) {
         var1 = var1.brighter();
      }

      super.setBackground(var1);
   }

   public native void setEditable(boolean var1);

   public native void select(int var1, int var2);

   public native int getSelectionStart();

   public native int getSelectionEnd();

   public native void setText(String var1);

   public native String getText();

   public native void setEchoCharacter(char var1);

   public void setEchoChar(char var1) {
      this.setEchoCharacter(var1);
   }

   public Dimension getPreferredSize(int var1) {
      return this.preferredSize(var1);
   }

   public Dimension getMinimumSize(int var1) {
      return this.minimumSize(var1);
   }

   public void setCaretPosition(int var1) {
      throw new AWTError("setCaretPosition is unimplemented.");
   }

   public int getCaretPosition() {
      throw new AWTError("getCaretPosition is unimplemented.");
   }

   public Dimension minimumSize() {
      FontMetrics var1 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      return new Dimension(var1.stringWidth(((TextField)super.target).getText()) + 20, var1.getHeight() + 6);
   }

   public Dimension preferredSize(int var1) {
      return this.minimumSize(var1);
   }

   public Dimension minimumSize(int var1) {
      FontMetrics var2 = ((MComponentPeer)this).getFontMetrics(super.target.getFont());
      return new Dimension(var2.charWidth('0') * var1 + 20, var2.getHeight() + 6);
   }

   public void handleAction() {
      MToolkit.postEvent(new ActionEvent(super.target, 1001, this.getText()));
   }

   protected void handleTextChanged() {
      MToolkit.postEvent(new TextEvent(super.target, 900));
   }

   public boolean isFocusTraversable() {
      return true;
   }
}
